/**********************************************************************
 *JimdoHoverプラグイン
 *jimdoHover_content.js
 *機能   (1)ジンドゥー編集で、youtube動画のリピート機能を追加します。
 *Jimdoの画面構成・構造は他のブラウザーとは少し異なっているようです。そのため、
 *DOMアクセスが難しくなっています。
 *編集画面で、リピート機能を保存しようとしましたが、うまくできませんでした。
 *そのため、動的にリピート機能を設定する方法をとっています。
 *あらかじめ、jquery.jsをロードしています。
 ***********************************************************************/
let tabId;
let frm_arr = [];
let rs;
let frame_count;
let cc = 0;
/*****************************************
*リロード毎にsaveTitle[]のリセットメッセージを送信
*  
********************************************/
chrome.runtime.sendMessage({type: "resetSaveTitle"}, function (response) {

});
//
$(function () {

    /*####################################
     *check_iframe()
     * 
     *####################################*/
    function check_iframe() {
        //iframe要素自体の属性は取得できる。
        let aaa;
        if(location.href.indexOf("ameblo") !== -1){
                aaa = document.querySelectorAll(".youtube_iframe");            

        }else if(location.href.indexOf("jimdo") !== -1){
                aaa = document.querySelectorAll(".cc-m-video-container");            

        }

        let sw = 0;
        let vid;
        for (let i = 0; i < aaa.length; i++) {
            //
            bbb = aaa[i].src;
            //ここで、vidを取得
            vid = bbb.split("?")[0].split("/")[4];

            //ここで、リピートを追加
            if (bbb.indexOf("&vq=hd1080") !== -1) {
                //?があれば
                if (bbb.indexOf("&autoplay") !== -1) {
                    continue;
                }
                else {
                    //リピート追加
                    //?autoplay=1&amp;loop=1&amp;playlist=
                    aaa[i].src = aaa[i].src.replace(/&vq=hd1080/, "&vq=hd1080&autoplay=1&amp;loop=1&amp;playlist=" + vid);
                    sw = 1;
                    continue;
                }
            }
        }
        //alert("リピート");
        //
        if (sw === 1) {
            //alert("リピート機能を追加しました。");
        }
        else {
            //alert("リピート設定されています。");    
        }
    }
    /*###############イベントリスナー##################　
     #$("body").on('click' 
     #ここのbodyは、jimdoページを指す。
     #リロードで、すべてのリスナーを登録します。
     #その後に、ctrlKey+clickすると、このイベントが発火します。
     ################イベントリスナー##################*/
    $("body").on('click', (e) => {
        if (e.altKey === true) {
            $("#pop").css("display","none");
            return false;
        }
        //jimdoページでctrlKey+clickされたかチェック
        if (e.ctrlKey === true) {
            $("#pop").css("display","block");
            /*************************************************************************************
             *ここが、何回も自動で呼ばれることがあるのは????? 
             *このリスナーが蓄積されているからか? 
             *リロードされるたびに、蓄積されるか??? 
             * 
             **************************************************************************************/
             //ここで、アメバとjimdoを区別して、ともに動作させるには


            if (location.href.indexOf("https://") !== -1) {
            //if (location.href.indexOf("https://tecoyan-net.jimdofree.com/") !== -1 && $(".cc-m-video-container").length !== 0) {
                //ここで、リピートを追加
                check_iframe();
/**********************************************************************************
 *popパネルの枠を表示 
 *動画情報表示用
 *すでにあれば、スキップ 
 ***********************************************************************************/
                if ($("#pop").length === 0) {
                    let html = "";
                    html += "<div id='pop' style='z-index:9999;padding:13px;overflow:scroll;background-color:lightpink;position:fixed;top:0%;left:50%;width:800px;height:550px;'>\n\
    <h2 style='float:left;background-color:lightyellow;'>動画データ(デバッグエイド)</h2><button id='none_disp' style='position:absolute;top:9%;left:90%;zoom:1.2;float:left;'>☒</button>\n\
    <span id='hover' style='position:absolute;margin-left:1%;background-color:lightgreen;width:400px;height:25px;float:left;'></span><br>\n\
    <div id='button' style='background-color: lightyellow;position: relative;width: 600px;height: 45px;top: 8%;'>\n\
    <button id='tabId' title='先にこのボタンでtabIdを設定してから、他のボタンのテストを行います。' style='position:absolute;top:9%;left:0%;zoom:1.1;float:left;'>tabId取得</button>\n\
    <button id='frameIds' style='position:absolute;top:9%;left:15%;zoom:1.1;float:left;'>frameIds取得</button>\n\
    <button id='webNavi' style='font-weight: bold;color: white;background-color: blue;position:absolute;top:9%;left:34%;zoom:1.1;float:left;'>webナビ</button>\n\
    <button id='save_disp' style='position:absolute;top:9%;left:50%;float:left;'>表示</button>\n\
    <button id='hovertrigger' style='position:absolute;top:9%;left:60%;zoom:1.1;float:left;'>保存</button>\n\
    <button id='reset' style='position:absolute;top:9%;left:70%;zoom:1.1;float:left;'>リセット</button>\n\
    </div>\n\
    <div id='popup' style='position:relative;top:8%;width:800px;height200px;clear:both;'></div>\n\
    <div id='videoInfo' style='position:relative;top:10%;width:800px;height200px;clear:both;'></div>\n\
    <div id='frame_count' style='display:none;'>0</div>\n\
<iframe id='sendemail' style='position: relative;left:50%;top: 20%;'src='https://sendemail.tecoyan.net/index.php'></iframe>\n\
    </div>";

                    if(location.href.indexOf("ameblo") !== -1){
                        $(".skin-columnB").append(html);

                    }else if(location.href.indexOf("jimdo") !== -1) {
                        $(".cc-page").append(html);

                    }
                    $("#pop").css("display","block");

                    $("#pop").draggable();
/***************************************************************************************
 *リスナーの登録は、登録する要素が表示されてから行う。 
 *表示実行して、1秒後にリスナー登録を行う。 
 ****************************************************************************************/
setTimeout(() => {
    $("#none_disp").on('click',()=>{
                //
                if($("#popup").css("display") === "block"){
                        $("#popup").css("display","none");
                        $("#sendemail").css("display","none");
                        $("#pop").css("height","100px");
                }else{
                        $("#popup").css("display","block");
                        $("#sendemail").css("display","block");
                        $("#pop").css("height","550px");
                }
    });   
/*########################################
 *get_tabIdメッセージ送信 
 * 
 *########################################*/
function sendMessage_tabId() {

    rs = new Promise(function (resolve) {
        //background.jsへ送信
        console.log("2. chrome.runtime.sendMessage({type: 'get_tabId'}を送信します。");
        chrome.runtime.sendMessage({type: "get_tabId"}, function (response) {
            console.log("6. backから応答が返りました。　" + response.tabId);
            resolve(response.tabId);
            console.log("7. resolveしました。　" + rs);

        });
        console.log("3. ここへは....");

    });
    //Promise(pending)を返す。
    console.log("4. ここは、いつ???");
    return rs;

}
/*##############イベントリスナー##################　
 *$("#tabId").on('click' 
 * 
 *###############イベントリスナー##################*/
$("#tabId").on('click', (e) => {
    rs = "";
    console.log("1. sendMessage_tabId().thenをコール");
    sendMessage_tabId().then(response => {
        //応答
        //
        tabId = response;
        console.log("8. .then " + tabId);
        $("#popup").html("tabId " + response);
        $("#popup").css({"display": "block", "zoom": 2});

    });
    //

    console.log("5. 非同期確認 tabId取得 " + rs);
    console.log(rs);
});


/*########################################
 *get_frameIdメッセージ送信 
 * 
 *########################################*/
function get_frameIdAll_message() {
    return new Promise(function (resolve) {
        //background.jsへ送信
        chrome.runtime.sendMessage({type: "get_frameIdAll"}, response => {
            console.log("get_frameIdAllの応答が来ました。　" + response);
            resolve(response);
        });
    });
};
/*##############イベントリスナー##################　
 *$("#frameIds").on('click' 
 * 
 *###############イベントリスナー##################*/
$("#frameIds").on('click', (e) => {
    console.log("get_frameIdAll()コール　");
    get_frameIdAll_message().then(resp => {
        //undefinedが返る時がある
        if(resp==="undefined"){
                //
                frm_arr = [];
        }else{
                frm_arr = resp;
                $("#frame_count").html(resp.length-1);
        }

        //ここで、pop画面に表示
        let html = "";
        $.each(frm_arr, (i, val) => {
            if(val.url.indexOf("https://www.youtube-nocookie.com/embed/")!==-1||val.url.indexOf("https://www.youtube.com/embed/?")!==-1){
                  html += "documentId:"+val.documentId + "<br>"+"frameId:"+val.frameId + "<br>"+"frameType:"+val.frameType + "<br>"+"parentDocumentId:"+val.parentDocumentId + "<br>"+"parentFrameId:"+val.parentFrameId + "<br>"+"processId:"+val.processId + "<br>"+"url:"+val.url + "<br>";
                  html += "*********************************************************<br>";

            } 

            //  

        });


        if (html === "framesId  <br>") {
            $("#frameIds").trigger('click');

        }
        else {
            $("#popup").html(html);
            $("#popup").css({"display": "block", "zoom": 2});
        }
    });
});
/*###############イベントリスナー##################　
 #$("#webNavi").on('click' 
 # 
 ################イベントリスナー##################*/
function sendMessage_webNavi() {
    //promiseを返却
    return new Promise(function (resolve) {
        //background.jsへwebNaviメッセージを送信
        console.log("sendMessage({type: 'webNavi'}を送信します。");
        //
        chrome.runtime.sendMessage({type: "webNavi"}, response => {
            //応答が返ります。
            //saveTitle[]にある
            console.log(response);
            resolve(response);
        });
    });
}
/*##############イベントリスナー##################　
 *webNavi
 * 
 *###############イベントリスナー##################*/
$("#webNavi").on('click', (e) => {
    //
    sendMessage_webNavi().then(message => {
        //応答はないので、以下は不要
        //結果の表示はgoPopupのexecuteScriptで表示

    });
});
/*##############イベントリスナー##################　
#$("#save_disp").on('click' 
#表示 
################イベントリスナー##################*/
$("#save_disp").on('click', () => {
    let data = $.ajax({
        url: 'https://favorite.tecoyan.net/slim/get_jimdo.php',
        type: 'GET',
        dataType: 'json',
        cache: false,
        //data: params,
        async: false
    }).responseText;
    let response = JSON.parse(data);
    console.log("get_jimdo  vid = " + response[0][0]);
    let html = "";
    $.each(response, (i, val) => {
        //
        html += "vid ：" + val[0] + "<br>tabId ：" + val[1] + "<br>frameId ：" + val[2] + "<br>title ：" + val[3] + "<br>ariaLabel ：" + val[4] + "<br><br><br>";
    });
    $("#videoInfo").html(`<div class='ariaInfo' style='zoom:1.5;background-color:lightblue;position:relative;top:0%;left:0%;width:600px;height:100px;'>` + html + `</div>`);
    document.querySelector("#popup").style.display = "block";
});
/*########################################
 *hoverTriggerメッセージ送信 
 *保存
 * 
 *########################################*/
function sendMessage_hoverTrigger() {
    return new Promise(function (resolve) {
        //background.jsへ送信
        console.log("sendMessage({type: 'hoverTrigger'}を送信します。");
        chrome.runtime.sendMessage({type: "hoverTrigger"}, response => {
            console.log("hoverTriggerの応答が来ました。　" + response);
            resolve(response);
        });
        return true;
    });

}
/*###############イベントリスナー##################　
 #$("#hovertrigger").on('click' 
 #保存したら、表示する。
 # 
 ################イベントリスナー##################*/
$("#hovertrigger").on('click', (e) => {
    //
    $("#frame_count").html(0);
    sendMessage_hoverTrigger().then(response => {
        //  
        //  
        $("#popup").html("保存 " + response);
        $("#popup").css({"display": "block", "zoom": 2});
        console.log("フレーム数　= "+$("#frame_count").html());
    }).then(()=>{
        setTimeout(()=>{
            //表示
            $("#save_disp").trigger('click');
        },2000);
    });
});


/**************************************************************
 *clickSetメッセージで、プレーヤーのコントロールにある再生/一時停止
 *ボタンにclickリスナーを登録(altKey押し下げ)
 *注意
 *このメッセージ送信は、popup画面が表示後に実行する。  
 ***************************************************************/
//このあと、background.jsへ通知する。
//再生/停止ボタンの設定登録
console.log("clickSetメッセージを送信します。");
chrome.runtime.sendMessage({type: 'clickSet'}, function (msg) {
    console.log("clickSetメッセージの応答が返りました。");
    //応答
    if (msg.sts === "completed") {
        //ここで、tabIdとfrm_arr[]をもらう。
        tabId = msg.tabId;
        frm_arr = msg.frm_arr;
        //alert("completedが返されました。");
        $("#tabId").trigger('click');

        //ここで削除すると、以後は、リロードしない限り、clickが効かない
        //$("body").off('click');
    }
});

/*##############イベントリスナー##################　
 #$("#reset").on('click' 
 # 
 ################イベントリスナー##################*/
//
$("#reset").on('click', () => {
    //
    $("#popup").html("");
    document.querySelector("#popup").style.display = "none";
    $(".ariaInfo").css("display", "none");
    chrome.runtime.sendMessage({type: "resetSaveTitle"}, function (response) {
    });

});
}, 1000);

}
}
}
});
//    
function get (url){
    let ft = fetch(url);
    console.log("fetch(url) "+ft);
    return ft;
}    
//テスト
async function fn(){
let urls =["https:","https:","https:"];
//urls[]をすべてget()したら、次へ
//今回は、ここでexecuteScript()ですべてDBへ更新したら、

console.log(await Promise.all(urls.map(get)));
console.log("Promise完了");




}    
//fn();
/*
 * 
 */
$("#plink").on('click', (e) => {
            //
            if (e.altKey === true) {

                            //リスナー
                            $("#plink").on("mouseenter", function (e) {
                              
                               alert("このプラグインは、埋め込み動画のDOMにアクセスして、\nタイトル他の情報をpop画面に表示します。\nまた、タイトルをクリックするとyoutubeサイトを開き、再生します。");
                               $("#plink").off('mouseenter');
                            });
                           

            }
});



});