/******************************************************************************
 *JimdoHoverプラグイン
 *jimdoHover_background.js
 *background.jsでは、window,jqueryは使用できず。
 *
 ******************************************************************************/
let active_tabId;
let tabId;
let extId;
let ownId;
let frm_arr = [];
let frm_arr_ = [];
//複数タブ対応　配列の中に複数のタブオブジェクトデータが入る
//
//
//
//[{{tabId:tabId,{{frameId:frameId,title:title},{frameId:frameId,title:title},{}....}},{},{}.....}]
let saveTitle = [];
let frm_data;
let ariaLabel;
let title;
let data;
let video_info = [];
//保存
let save = [];
let html = "テスト";

//リスナーを登録すると、以後は、アクションがあるごとにこの処理を実行
//引数は、targetとfilesのオブジェクト
chrome.action.onClicked.addListener(
async (tab) => {
console.log("これは、ameblojimdoプラグインです。");
//アクティブタブのすべてのframeに対して、executeTestスクリプトを実行  
await chrome.scripting.executeScript({
target : {tabId : tab.id, allFrames : false},
args: [],
//実際に実行するexcuteScriptコード
//ここで、タイトル他をsaveTitle[]に保存するsaveTitleメッセージを
//background.jsへ送信
func: () => {
/**********************************************************
//以下のコードは、ブラウザーのアドレスバーの右横にあるameblojimdo
//プラグインボタンをクリックすると実行するイベントリスナーです。
//ここで、アクティブタブでexecuteScript()を実行する関数を定義して
//います。定義している場所は、プラグインのbacjground.jsです。
//func: () => {...}部分が実際に実行するコードです。
            
chrome.action.onClicked.addListener(
async (tab) => {
console.log("これは、ameblojimdoプラグインです。");
//アクティブタブのすべてのframeに対して、executeTestスクリプトを実行  
await chrome.scripting.executeScript({
      target : {tabId : tab.id, allFrames : false},
      args: [],
      //実際に実行するexcuteScriptコード
      //
      func: () => {
        //このコードはアクティブのタブのページタイトルを取得して、
        //表示します。
        //このページのドキュメント(DOM)にアクセスして、
        //タイトルを取得 
        console.log("executeScript Test: "+document.title+"  ");

      }
});
}
);
*このコードはアクティブのタブのページタイトルを取得して、
*表示します。
*このページのドキュメント(DOM)にアクセスして、
*タイトルを取得  
********************************************************/
console.log("executeScript Test: "+document.title+"  ");

}
});
}
);


const sleep = (s) => {
    new Promise(f => setTimeout(f, s * 1000));
    console.log("sleep test");
};

/***************************************************************************
 *メッセージ受信処理
 *msg.typeで分岐
 *clickSetメッセージ　　　　　　　　　//
 *saveTitleメッセージ　　　　　　　　// 
 *webNaviメッセージ　　　　　　　　 //  
 *hoverTriggerメッセージ　　　　　　//
 *get_tabIdメッセージ　　　　　　　　//  
 *get_frameIdAllメッセージ　　　　　//
 *hoverメッセージ                      // 
 *hover-leaveメッセージ             //
 *sendEmailメッセージ                //
 *altTriggerメッセージ                //   
 *
 *このパターンを使うと応答が取れる。
 *同期型
 *content.js側から、xxxメッセージを送信し、その結果を応答で取得するパターン
 *
 *****************************************************************************/
chrome.runtime.onMessage.addListener(
        function (msg, sender, sendResponse) {
            /*************************************************
             *メッセージチェック
             *content.jsからのメッセージを待つ。
             * 
             **************************************************/
            switch (msg.type) {
                /***************************************************************
                 *clickSetメッセージ 
                 *すべての動画フレームに対して、再生/一時停止ボタン要素のclickリスナーを登録 
                 * パラメータはなし。
                 * どこで、sendResponse()で応答を返すか?????
                 * 
                 *****************************************************************/
                case "clickSet":
                    console.log("clickSetメッセージを受信しました。　");
                    saveTitle = [];
                    extId = chrome.runtime.id;
                    //

                    /*************************************************************************
                     *タブはアクティブタブのみが対象 
                     *
                     ****************************************************************************/
                    chrome.tabs.query({}, tabs => {
                        for (const tab of tabs) {
                            /*********************************************************
                             *iframeプレーヤーチェック
                             *ここで、今開いているタブのみにする　アクティブのタブ  
                             *********************************************************/
                            if (tab.active === true) {
                                console.log("Msg■clickSet  for ループ　" + tab.id);
                                tabId = tab.id;
                                try {
                                    //urlをチェック
                                    if (tab.url.indexOf("https://") !== -1) {
                                        //if (tab.url.indexOf("https://tecoyan-net.jimdofree.com/") !== -1) {
                                        //ここで、タブの全フレームデータを取得して保存
                                        //chrome.webNavigation.getAllFrames({tabId: tabId}).then(logFrameInfo1, onError);
                                        chrome.webNavigation.getAllFrames({'tabId': tabId}, framesInfo => {
                                            frm_arr = [];
                                            for (const frm of framesInfo) {
                                                console.log("Msg■clickSet  frm.frameId　= " + frm.frameId);
                                                frm_arr.push(frm.frameId);

                                                try {
                                                    /*********************************************************
                                                     *youtube iframeプレーヤーチェック
                                                     *今開いているタブのみにする　アクティブのタブ
                                                     *frameType sub_frameのみ
                                                     *    
                                                     *********************************************************/
                                                    if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.youtube-nocookie.com/embed/") !== -1 || frm.url.indexOf("https://www.youtube.com/embed/") !== -1)) {
                                                        //if (frm.frameType === "sub_frame"&&frm.url.indexOf("/embed/")!==-1) {
                                                        console.log("Msg■clickSet  フレームInfo url = " + frm.url + "  " + frm.frameId);
                                                        //executeScript()を実行
                                                        //filesとfuncを同時に指定できないので分けて出す。
                                                        chrome.scripting.executeScript({
                                                            target: {tabId: tabId, frameIds: [frm.frameId]},

                                                            files: ["jquery.js"]
                                                        }).then(() => {
                                                            /*******************************************************************
                                                             *executeScript()を起動します。
                                                             *  
                                                             *******************************************************************/
                                                            console.log("■■■executeScript()を起動します。　" + frm.frameId);
                                                            //ここでもexecuteScript()を出す
                                                            try {
                                                                chrome.scripting.executeScript({
                                                                    //ターゲットのフレームIdのDOMへアクセス  
                                                                    target: {tabId: tabId, frameIds: [frm.frameId]},
                                                                    /*************************************************************
                                                                     *hoverメッセージで渡すパラメーター
                                                                     * frm.frameId,
                                                                     * extId,
                                                                     * frm_arr,
                                                                     * tabId,
                                                                     * frm.frameId
                                                                     * 
                                                                     ****************************************************************/
                                                                    args: [frm.frameId, extId, frm_arr, tabId, frm.frameId],
                                                                    //実際に実行するexcuteScriptコード
                                                                    //ここで、タイトル他をsaveTitle[]に保存するsaveTitleメッセージを
                                                                    //background.jsへ送信
                                                                    func: (frameId, extId, frm_arr, tabId, ownId) => {

                                                                        /*****************************************************
                                                                         *altKeyリスナー処理
                                                                         *altKey+click操作
                                                                         *  
                                                                         ******************************************************/
                                                                        $(function () {
                                                                            $("body").on('click', (e) => {
                                                                                let aa = document.querySelector(".ytp-play-button");
                                                                                let tt;
                                                                                /**********************************************************
                                                                                 *altKey押し下げは、一回目は不安定なため、続けて2回目は正しい結果に 
                                                                                 * なる。原因は不明。
                                                                                 *************************************************************/
                                                                                if (e.altKey === true) {
                                                                                    //alert("altKeyが押されました。 " + frameId + "  " + document.title + "  " + aa.ariaLabel);
                                                                                    //このdocumentは、altKeyを押している動画のドキュメント
                                                                                    if (aa.title !== "") {
                                                                                        tt = aa.title;
                                                                                    }
                                                                                    else {
                                                                                        tt = aa.ariaLabel;
                                                                                    }
                                                                                    console.log("Msg■clickSet  altKey クリック時のタイトル　" + document.title + "　フレーム(" + frameId + ")　" + tt);
                                                                                    /***************************************************************************
                                                                                     *ここで、'altTrigger'メッセージを送信
                                                                                     *popパネルにボタン情報を表示
                                                                                     *ariaLabelの表示内容が安定しない??? 
                                                                                     *再生/一時停止ボタンのariaLabelの内容とボタンのホバー時の内容が一致しない???                                                                           * 
                                                                                     ****************************************************************************/
                                                                                    //alert("Altキー　押し下げ　"+ownId);
                                                                                    let dd = {type: 'altTrigger', frm_arr: frm_arr, tabId: tabId, ownId: ownId, title: document.title, ariaLabel: tt};
                                                                                    chrome.runtime.sendMessage(extId, dd, function (msg) {
                                                                                        //応答は? 特になし。     
                                                                                    });
                                                                                }
                                                                            });
                                                                            /********************************************************************
                                                                             *ホバーした時のtitle属性をとれるか
                                                                             *再生ボタンをホバーすると、
                                                                             * 
                                                                             *********************************************************************/
                                                                            /*イベントリスナー登録*/
                                                                            console.log("ボタンに、ホバーイベントを登録します。");
                                                                            $(document).on({
                                                                                "mouseenter": function (e) {
                                                                                    //alert("マウスエンター");
                                                                                    //ここで、title属性を取得
                                                                                    let aa = document.querySelector(".ytp-play-button");
                                                                                    if (aa.title === "") {
                                                                                        /*************************************************
                                                                                         *ここで、video_infoを取得して、hoverメッセージとともにbackへ 
                                                                                         *送信する 
                                                                                         *
                                                                                         *************************************************/
                                                                                        //let dd = {vid:'xxxx',title:'wwww',thumbnail:'cccc',frameId:'ffffff'};
                                                                                        chrome.runtime.sendMessage(extId, {type: "hover", ariaLabel: aa.ariaLabel, frameId: frameId, title: document.title, tabId: tabId}, function (msg) {
                                                                                            //応答は? 特になし。
                                                                                            console.log(msg);
                                                                                            //sendEmail();
                                                                                            //alert(msg);
                                                                                        });
                                                                                    }
                                                                                    else {
                                                                                        //alert(aa.title);
                                                                                        chrome.runtime.sendMessage(extId, {type: "hover", ariaLabel: aa.title, frameId: frameId, title: document.title, tabId: tabId}, function (msg) {
                                                                                            //応答は? 特になし。
                                                                                            console.log(msg);
                                                                                            /********************************************************
                                                                                             *この関数が見つからないのは、フレーム0で、別のフレームにある関数を
                                                                                             *呼び出しているため。
                                                                                             * 
                                                                                             *********************************************************/
                                                                                            //sendEmail();
                                                                                            //alert(msg);
                                                                                        });
                                                                                    }
                                                                                },
                                                                                "mouseleave": function (e) {
                                                                                }
                                                                            }, ".ytp-play-button");

                                                                            /****************************************************************
                                                                             *再生/一時停止ボタンをクリック
                                                                             *ここで、今の動画情報を更新する。
                                                                             *  
                                                                             ****************************************************************/
                                                                            console.log("再生ボタンのクリックイベントを登録します。");
                                                                            $(".ytp-play-button").on('click', () => {
                                                                                //alert("再生ボタンがクリックされました。");
                                                                            });

                                                                        });


                                                                    }       //end func() executeScript()
                                                                });         //end executeScript()
                                                            }
                                                            catch (err) {
                                                                console.error(`failed to execute script: ${err}`);

                                                            }

                                                        });
                                                        console.log("sendResponseを返します。");
                                                        //最後で返したいが、動画の数でチェックするか?
                                                        //sub_frameの最後を見たいが
                                                        sendResponse({sts: "completed"});
                                                        //end .then(()=>{ 
                                                        //await sleep(0.5);
                                                    }
                                                    else {

                                                    }
                                                }   //try()
                                                catch (e) {

                                                }

                                            }       // end for()
                                        })();       //end async()
                                        console.log("Msg■clickSet  getAllFrames()コール後　" + tabId);
                                        //await sleep(0.5);
                                    }
                                    else {

                                    }


                                }
                                catch (e) {
                                    //なし
                                }


                            }
                        }


                    });
                    /***********************************************************
                     *これは、必要
                     *後のsendResponse()を有効にするため、 
                     ***********************************************************/
                    return true;

                    break;


                case "resetSaveTitle":
                    
                    saveTitle = [];
                    return true;
                    break;
                    
                    /************************************************************
                     *ここで、タイトルを一時保管
                     *msgにデータ  msg.frameId, msg.title
                     *executeScript()毎に
                     ************************************************************/
                case "saveTitle":
                     if(msg.title===undefined){
                         //console.log('■■case "saveTitle": msg.title===undefined');
                         break;
                     }   
                    //saveTitle[]のリセットは、いつ? clickSet受信時にリセットしてから保存
                    let dd = {frameId: msg.frameId, title: msg.title,vid:msg.vid};
                    saveTitle.push(dd);

                    console.log("■■saveTitleの長さ　" + saveTitle.length);

                    for (const frameInfo of saveTitle) {
                        console.log("saveTitle " + frameInfo.title);
                    }
                    sendResponse({content: "back 応答", saveTitle: saveTitle});

                    return true;
                    break;
case "webNavi":
        extId = chrome.runtime.id;
        /*****************************************************************
         *手順
         *(1)executeScript()で、各動画でインジェクションスクリプトを実行　 
         *・background.jsへフレームIdと動画タイトルのペアをsaveTitle配列にプッシュ
         *・
         *webNaviは応答はしていない。  
         ********************************************************************/
        saveTitle = [];
        //console.log("■■saveTitle[]の長さ　"+saveTitle.length);
        chrome.tabs.query({}, (tabs) => {
                //
                for (const tab of tabs) {
                    /*********************************************************
                     *iframeプレーヤーチェック
                     *ここで、今開いているタブのみにする　アクティブのタブ  
                     *********************************************************/
                    if (tab.active === true) {
                        //if (tab.url.indexOf("https://") !== -1) {
                        //if (tabs[i].url.indexOf("https://tecoyan-net.jimdofree.com/") !== -1) {    
                        active_tabId = tab.id;
                        tabId = tab.id;
                        console.log("ここで、tabIdをセット　" + tabId);
                        /******************************************************************
                         *ここでawaitを出す。 
                         *tabs[]を取得したら、.then()メソッドで、logAllFrames()関数をコール。
                         *引数は、tabs
                         *******************************************************************/
                        logAllFrames();

                        break;
                        //}
                        //sleep(0.5);
                    }
              }
              function logAllFrames() {
                //タブがいくつあるか、アクティブタブのtabIdが対象

                console.log("■back webNavigation.getAllFrames  tabId = " + tabId);
                //frameIds[]を取得
                chrome.webNavigation.getAllFrames({tabId: tabId, }).then(logFrameInfo);
                //chrome.webNavigation.getAllFrames({tabId: tabId}, (framesInfo) => {

                function logFrameInfo(framesInfo) {
                    const frm_arr = Object.values(framesInfo);
                    frm_arr_ = [];
                    for (const frm of frm_arr) {
                        //ここで、frm.urlをチェック　必要なものだけ保存
                        if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.youtube-nocookie.com/embed/") !== -1 || frm.url.indexOf("https://www.youtube.com/embed/") !== -1)) {
                            console.log("Msg■clickSet  frm.frameId　= " + frm.frameId);
                            frm_arr_.push(frm.frameId);
                        }else{
                            continue;
                        }
                        try {
                            /*********************************************************
                             *youtube iframeプレーヤーチェック
                             *今開いているタブのみにする　アクティブのタブ
                             *frameType sub_frameのみ
                             *    
                             *********************************************************/
                            if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.youtube-nocookie.com/embed/") !== -1 || frm.url.indexOf("https://www.youtube.com/embed/") !== -1)) {
                                //if (frm.frameType === "sub_frame"&&frm.url.indexOf("/embed/")!==-1) {
                                console.log("Msg■clickSet  フレームInfo url = " + frm.url + "  " + frm.frameId);
                                //executeScript()を実行
                                //filesとfuncを同時に指定できないので分けて出す。
                                chrome.scripting.executeScript({
                                    target: {tabId: tabId, frameIds: [frm.frameId]},

                                    files: ["jquery.js"]
                                }).then(() => {
                                    /*******************************************************************
                                     *executeScript()を起動します。
                                     *  
                                     *******************************************************************/
                                    console.log("■■■executeScript()を起動します。　" + frm.frameId);
                                    //ここでもexecuteScript()を出す
                                    try {
                                        chrome.scripting.executeScript({
                                            //ターゲットのフレームIdのDOMへアクセス  
                                            target: {tabId: tabId, frameIds: [frm.frameId]},

                                            args: [frm.frameId, extId, frm_arr_, tabId, frm.frameId],
                                            //実際に実行するexcuteScriptコード
                                            //ここで、タイトル他をsaveTitle[]に保存するsaveTitleメッセージを
                                            //background.jsへ送信
                                            func: (frameId, extId, frm_arr, tabId, ownId) => {
                                                /***************************************************************************
                                                 *webNaviメッセージ executeScript()の処理関数
                                                 *特定のtabIdの特定のframeIdで動作
                                                 *タイトルを表示して、saveTitleメッセージをbackground.jsへ送信する。
                                                 *ここで、動画のurlも指定? https://www.youtube.com/watch?v=iDNPZE9G28E形式で
                                                 ****************************************************************/
                                                //alert("タイトル表示　" + document.querySelectorAll(".ytp-title-link")[0].innerText);
                                                //backへframeIdとタイトルを渡す　backでそれらを一時保管
                                                let title = document.title;
                                                //alert("saveTitle url = " + document);
                                                //amebloとjimdoで分ける?
                                                let vid;
                                                /****************************************************
                                                *vid 仕分け処理
                                                *形式チェック
                                                * 
                                                *******************************************************/
                                               
                                                if(document.location.href.indexOf("nocookie.com")!==-1){
                                                      //埋め込み動画のjimdo形式  
                                                      vid = document.location.href.split("/")[4].split("?")[0];
                                                }else if(document.location.href.indexOf("autoplay")!==-1){
                                                     //ameblo
                                                     vid = document.location.href.split("=")[3].split("&")[0];
                                                }else{
                                                     //ameblo
                                                     vid = document.location.href.split("/")[4].split("?")[0];
                                                }
                                                console.log("webNaviでvidを取得　"+vid);

                                                let dd = {type: 'saveTitle', frameId: frameId, title:title,vid:vid};
                                                    chrome.runtime.sendMessage(extId, dd, function (msg) {

                                                                let dd = {type: 'goPopup'};
                                                                chrome.runtime.sendMessage(extId, dd, function (msg) {
                                                                    //応答はなし。     
                                                                });

                                                    });

                                                }       //end func() executeScript()
                                            });         //end executeScript()

                                        }
                                        catch (e) {

                                        }
                                    });
                                }

                            }
                            catch (e) {

                            }

                        }       // end for()
                    }
              }
      });       //end async()
   //saveTitle = [];
    /*******************************************************
     *アクティブタブの動画フレームを取得 
     *frameIdとタイトルのペアを表示したい。 
     *動画のタイトルはdocument.titleで取得できるが、
     *この時タイトルはsaveTitle[]にあるので、それを応答する。 
     **********************************************************/
    function onError(error) {
        console.error(`Error: ${error}`);
    }

    //
    return true;
    break;
                    /*
                     * 
                     */
                case "goPopup":
                    /*
                     *htmlデータを#popupセレクターに表示するexecuteScriptを発行
                     *tabId,frameId=0,htmlデータ
                     */
                    //以下はexecuteScript()で実行する。
                    chrome.scripting.executeScript({
                        target: {tabId: tabId, frameIds: [0]},
                        files: ["jquery.js"]
                    }).then(() => {
                        /******************************************************
                        *表示用のhtmlを生成
                        *saveTitle[]をもとに
                        *タイトルにリンクを付ける場合は、対象のurlを取得して、<a src='対象url'>..</a>とする
                        *このurlはどこから、引数にしておかないと  
                        ********************************************************/
                       if(saveTitle[0].vid ===""){
                           saveTitle[0].vid = "ちちちち";
                       }

                        let html = "<br>";
                        for (let i = 0; i < saveTitle.length; i++) {
                            html += saveTitle[i].frameId + " ,<a target='_blank' style='color:blue;' href='https://www.youtube.com/watch?v="+saveTitle[i].vid+"'>" +saveTitle[i].title + "</a><br>";
                        }

                        //ここでもexecuteScript()を出す
                        chrome.scripting.executeScript({
                            //ターゲットのフレームIdのDOMへアクセス  
                            target: {tabId: tabId, frameIds: [0]},
                            //引数
                            args: [tabId, html],
                            //実行コード
                            func: (tabId, html) => {
                                /******************************************************
                                *goPopup  executeScript()を実行 
                                *これは、埋め込み動画のdocument空間で実行
                                ******************************************************/
                                //alert("goPopで表示します。");
                                $("#popup").html("webNavi " + html);
                                $("#popup").css({"display": "block", "zoom": 2});



                            }

                        });

                    });
                    //必須
                    return true;
                    break;

                case "hoverTrigger":

                    /*****************************************************************
                     *事前にtabIdを取得しておくことが前提
                     * 
                     ******************************************************************/
                    console.log("■Msg hoverTrigger受信 tabId= " + tabId);
                    //整形
                    frm_data = [];
                    /********************************************************************
                     *webNavigation.getAllFrames(....) 
                     * 
                     ************************************************************************/
                    (async () => {

                        console.log("■■■webNavigation.getAllFrames  tabId = " + tabId);
                        frm_arr = await chrome.webNavigation.getAllFrames({tabId: tabId});
                        console.log("■ここで、webNavigationの応答　" + frm_arr);
                        /****************************************************************
                         *すべての動画フレームが対象 
                         *パラメーター　：　
                         **************************************************************************/
                        frm_arr_ = [];
                        for (const frm of frm_arr) {
                            //ここで抽出
                            if (frm.url.indexOf("https://www.youtube-nocookie.com/embed/") !== -1 || frm.url.indexOf("https://www.youtube.com/embed/") !== -1) {
                                try {
                                    /*********************************************************
                                     *frameType sub_frameのみ
                                     *    
                                     *********************************************************/
                                    if (frm.frameType === "sub_frame") {
                                        /******************************************************
                                         *すべてのfr_arr[]を取得して、メッセージに応答する。 
                                         *sendResponse(); 
                                         ********************************************************/
                                        frm_arr_.push(frm.frameId);
                                        //ここで、0.5秒待つ                                        
                                        //await sleep(0.5);

                                    }
                                    else {

                                    }
                                }
                                catch (e) {

                                }
                            }
                        }
                        //フレーム0は配列の最後に
                        frm_arr_.push(0);
                        /***********************************************************
                         *frm_arr_をもとに、 
                         *DB保存 
                         * 
                         ************************************************************/
                        //ここが最後の出口　ここで、DBへ出力は?
                        //            data = [];
                        for (const frm of frm_arr_) {

                            console.log("■Msg hoverTrigger 次のfrm " + frm);
                            //frm 0は除く
                            if (frm !== 0) {

                                //以下はexecuteScript()で実行する。
                                chrome.scripting.executeScript({
                                    target: {tabId: tabId, frameIds: [frm]},
                                    files: ["jquery.js"]
                                }).then(() => {
                                    //ここでもexecuteScript()を出す
                                    chrome.scripting.executeScript({
                                        //ターゲットのフレームIdのDOMへアクセス  
                                        target: {tabId: tabId, frameIds: [frm]},
                                        //引数
                                        args: [tabId, frm],
                                        //実行コード
                                        func: (tabId, frm) => {
                                            /******************************************************
                                            *hoverTrigger
                                            *  
                                            **********************************************************/
                                            console.log("■Msg hoverTrigger executeScript()呼び出し　" + frm);
                                            /******************************************************
                                             *hoverTrigger  executeScript()を実行 
                                             *
                                             ******************************************************/
                                            //jimdoとamebloに分けて処理
                                            
//                                            var a = $(".ytp-play-button");
//                                            let tt;
//                                            if (a.title !== "") {
//                                                tt = a.title;
//                                            }
//                                            else {
//                                                tt = a.ariaLabel;
//                                            }
                                            console.log("■Msg hoverTrigger " + tabId + " " + frm + " " +document.title);
                                            
                                            /**************************************************************
                                             *DBへ保存
                                             *  
                                             *******************************************************************/
                                            //保存は場所は、DB 動画毎に保存
                                            let vid;
                                            if(document.URL.indexOf("https://www.youtube.com/embed/?autoplay")!==-1){
                                                vid=document.URL.split("=")[3].split("&")[0];
                                            }else{
                                                
                                                vid=document.URL.split("/")[4].split("?")[0];
                                            }
                                            
                                            let params = {
                                                vid: vid,
                                                tabId: tabId,
                                                frameId: frm,
                                                title: document.title,
                                                ariaLabel: "テスト"
                                            };
                                            var data = $.ajax({
                                                url: 'https://favorite.tecoyan.net/slim/save_jimdo.php',
                                                type: 'POST',
                                                dataType: 'html',
                                                cache: false,
                                                data: params,
                                                async: false
                                            }).responseText;
                                            console.log("■■■Msg hoverTrigger DB保存しました。" + data + "  " + document.title);
                                            console.log("sendResponse直前　");

                                        }

                                    });

                                });

                            }
                            else {
                                console.log("save_jimdo.php 154行  DB保存しました。 " + frm);

                            }

                        }     //for() end 
                        /**************************************************************
                         * frame　0で実行　executeScript()　スクリプトインジェクション
                         *
                         * 
                         **************************************************************/
                        //ここで、frame　0に対して、executeScript()を出して、Promise.all()または、
                        //alert()で完了を通知
                        //以下はexecuteScript()で実行する。
                        chrome.scripting.executeScript({
                            target: {tabId: tabId, frameIds: [0]},
                            files: ["jquery.js"]
                        }).then(() => {
                            //ここでもexecuteScript()を出す
                            chrome.scripting.executeScript({
                                //ターゲットのフレームIdのDOMへアクセス  
                                target: {tabId: tabId, frameIds: [0]},
                                //引数
                                args: [],
                                //実行コード
                                func: () => {
                                    /**************************************************
                                     *frame0で実行　executeScript()　スクリプトインジェクション
                                     *  
                                     ****************************************************/
                                    console.log("■すべてのDB更新が完了しました。");
                                    //alert("■すべてのDB更新が完了しました。");

                                }

                            });
                            //ここは、DB更新が完了ではなく、executeScript()の発行がすべて完了したことの意味
                            sendResponse("すべてのexecuteScript()を発行しました。" + frm_arr[0].frameId, frm_arr[1].frameId, frm_arr[2].frameId, frm_arr[3].frameId);
                        });
                    })();
                    //必須
                    return true;
                    break;
                    /***********************************************
                     *get_tabId
                     * 
                     *************************************************/
                case "get_tabId":
                    console.log("■get_tabIdメッセージを受信 " + tabId);
//(async()=>{
                    //このメソッドは、非同期なので、結果を待たずに、先にリターンする。
                    //そのため、あとからのsendResponse送信を有効にするため、return trueしている。
                    chrome.tabs.query({}, tabs => {
                        for (const tab of tabs) {
                            /*********************************************************
                             *iframeプレーヤーチェック
                             *ここで、今開いているタブのみにする　アクティブのタブ  
                             *********************************************************/
                            if (tab.active === true) {
                                if (tab.url.indexOf("https://") !== -1) {
                                    //if (tabs[i].url.indexOf("https://tecoyan-net.jimdofree.com/") !== -1) {    
                                    active_tabId = tab.id;
                                    tabId = tab.id;
                                    console.log("ここで、tabIdをセット　" + tabId);
                                    break;
                                }
                                sleep(0.5);
                            }
                        }

                        console.log("tabId ここで応答 " + tabId);
                        //ここでの応答を有効にするため、return trueをあらかじめ、返している。
                        sendResponse({tabId: tabId});


                    });
                    //これが必要
                    //これは、リスナーがリターンした後でも、sendResponseへの参照が有効になる設定。
                    //非同期応答を有効にしている。
                    console.log("return true");
                    return true;

                    break;
                    /*****************************************************************
                     *get_frameIdAll
                     *webNavigation.getAllFrames() 
                     ******************************************************************/
                case "get_frameIdAll":
                        console.log("webNavigation tabId = " + tabId);
                chrome.webNavigation.getAllFrames({tabId:
                        tabId, }).then(logFrameInfo);
                    //
                    function logFrameInfo(framesInfo) {
                        const frm_arr = Object.values(framesInfo);
                        frm_arr_ = [];
                        for (const frm of frm_arr) {
                            try {
                                /*********************************************************
                                 *frameType sub_frameのみ
                                 *    
                                 *********************************************************/
                                if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.youtube-nocookie.com/embed/") !== -1 || frm.url.indexOf("https://www.youtube.com/embed/") !== -1)) {
                                    /******************************************************
                                     *すべてのfr_arr[]を取得して、メッセージに応答する。 
                                     *sendResponse(); 
                                     ********************************************************/
                                    frm_arr_.push(frm);
                                    sleep(0.5);

                                }
                                else {

                                }
                            }
                            catch (e) {

                            }
                        }

                        console.log("■logFrameInfo_get_frm_arr() return " + frm_arr_);
                        //return frm_arr_;
                        sendResponse(frm_arr_);
                    }
                    //必須
                    return true;

                    break;
                    /**********************************************************
                     *hoverメッセージを受信 
                     *ここでのframeIdは、0でなく、urlがhttps://sendemail.tecoyan.net 
                     *のframeIdである。 
                     * 
                     ************************************************************/
                case "hover":

                    console.log("hover受信");
                    //親フレーム　frameId = 0へ、executeScript()を出す。
                    //tabIdが消えている現象が発生
                    chrome.scripting.executeScript({
                        target: {tabId: msg.tabId, frameIds: [0]},
                        files: ["jquery.js"]
                    }).then(() => {
                        //ここでもexecuteScript()を出す
                        chrome.scripting.executeScript({
                            //ターゲットのフレームIdのDOMへアクセス  
                            target: {tabId: msg.tabId, frameIds: [0]},
                            //msgからタイトルを取得
                            args: [msg.ariaLabel, msg.frameId, msg.title],
                            //実行コード
                            func: (ariaLabel, frameId, title) => {
                                let extId = chrome.runtime.id;
                                /***************************************************************
                                 *"hover"のexecuteScript() 
                                 *ここからが、インジェクション　スクリプト 
                                 ****************************************************************/
                                //alert("ホバーして表示します。");
                                console.log("hoverテスト executeScript()は、しばらくしてから");
                                //ここで、#hoverへステータスを表示
                                //動画のframeIdも表示
                                $("#hover").html(ariaLabel + "  <span style='background-color:lightblue;'>" + frameId + "   " + title + "</span>");
                                if ($("#hover").css("background-color") === "rgb(173, 216, 230)") {

                                    $("#hover").css("background-color", "lightgreen");
                                    $("#hover").css("zoom", "1.0");

                                }
                                else {
                                    $("#hover").css("background-color", "rgb(173, 216, 230)");
                                    $("#hover").css("zoom", "1.0");
                                }

                                //vid,title,thumbnail
                                function db_save(info) {
                                    param = {
                                        data: info
                                    };
                                    let data;
                                    data = $.ajax({
                                        url: "https://sendemail.tecoyan.net/save_data_db.php",
                                        type: 'POST',
                                        dataType: 'html',
                                        cache: false,
                                        data: param,
                                        async: false
                                    }).responseText;
                                    //
                                    console.log("保管しました。" + data);
                                }
                                //ここで、動画の情報を取得して、DBへ保存
                                let video_info = {ariaLabel: ariaLabel, frameId: frameId, title: title};
                                //alert(title + "  \n続けてメールを送信します。");
                                db_save(video_info);

                                //ここで、sendEmailメッセージを送る
                                let dd = {type: 'sendEmail', frm_arr: frm_arr, tabId: tabId, title: title};
                                chrome.runtime.sendMessage(extId, dd, function (msg) {

                                    //応答は? 特になし。     
                                });
                            }
                        });
                        //ここで、応答を返す。
                        //応答は、ホバー処理を終了後に返す。
                    }).then(sendResponse("hoverメッセージ処理終了　executeScript()よりも先に来る"));
                    //
                    return true;
                    break;
                    /*************************************************************************************
                     *hover_leaveメッセージ 
                     * 
                     ****************************************************************************************/
                case "hover_leave":
                    console.log("hover_leave受信");
                    //親フレーム　frameId = 0へ、executeScript()を出す。
                    chrome.scripting.executeScript({
                        target: {tabId: tabId, frameIds: [0]},
                        files: ["jquery.js"]
                    }).then(() => {
                        //ここでもexecuteScript()を出す
                        chrome.scripting.executeScript({
                            //ターゲットのフレームIdのDOMへアクセス  
                            target: {tabId: tabId, frameIds: [0]},

                            args: [],
                            //実行コード
                            func: () => {
                                /*******************************************************
                                 *hover_leave executeScript()
                                 *  
                                 *********************************************************/
                                //alert("ホバーリーブします。");
                                console.log("hover_leaveします。");
                                //ここで、#hoverへステータスを表示
                                $("#hover").html("");

                            }
                        });

                    });
                    //
                    return true;
                    break;
                case "sendEmail":
                    //ここで、executeScriptで、sendEmail()をコールする。
                    //アクティブタブの当該frameIdに対して、
                    //これをテンプレートに不要なスクリプトを削除する手法で。
                    extId = chrome.runtime.id;
                    /*************************************************************************
                     *タブはアクティブタブのみが対象 
                     *
                     ****************************************************************************/
                    chrome.tabs.query({}, tabs => {
                        for (const tab of tabs) {
                            /*********************************************************
                             *iframeプレーヤーチェック
                             *ここで、今開いているタブのみにする　アクティブのタブ  
                             *********************************************************/
                            if (tab.active === true) {
                                console.log("Msg■sendEmail  for ループ　" + tab.id);
                                tabId = tab.id;
                                try {
                                    //urlをチェック  jimdofreeページ                  
                                    if (tab.url.indexOf("https://") !== -1) {
                                        //if (tab.url.indexOf("https://tecoyan-net.jimdofree.com/") !== -1) {    
                                        //ここで、タブの全フレームデータを取得して保存
                                        //chrome.webNavigation.getAllFrames({tabId: tabId}).then(logFrameInfo1, onError);
                                        chrome.webNavigation.getAllFrames({'tabId': tabId}, framesInfo => {
                                            frm_arr = [];
                                            for (const frm of framesInfo) {
                                                console.log("Msg■clickSet  frm.frameId　= " + frm.frameId);
                                                frm_arr.push(frm.frameId);

                                                try {
                                                    /*********************************************************
                                                     *youtube iframeプレーヤーチェック
                                                     *ホバーした動画をチェック                                                     *
                                                     *frameType sub_frameで且つ、
                                                     *    
                                                     *********************************************************/
                                                    if (frm.url === "https://sendemail.tecoyan.net/index.php") {
                                                        console.log("Msg■sendEmail  フレームInfo url = " + frm.url + "  " + frm.frameId);
                                                        //executeScript()を実行
                                                        //filesとfuncを同時に指定できないので分けて出す。
                                                        chrome.scripting.executeScript({
                                                            target: {tabId: tabId, frameIds: [frm.frameId]},

                                                            files: ["jquery.js"]
                                                        }).then(() => {
                                                            /*******************************************************************
                                                             *executeScript()を起動します。
                                                             *  
                                                             *******************************************************************/
                                                            console.log("■■■executeScript()を起動します。　" + frm.frameId);
                                                            //ここでもexecuteScript()を出す
                                                            try {
                                                                chrome.scripting.executeScript({
                                                                    //ターゲットのフレームIdのDOMへアクセス  
                                                                    target: {tabId: tabId, frameIds: [frm.frameId]},
                                                                    /*************************************************************
                                                                     *sendEmailメッセージで渡すパラメーター
                                                                     *frm.frameId,
                                                                     *extId,
                                                                     *tabId,
                                                                     *宛先、メッセージタイトル、内容 
                                                                     * 
                                                                     ****************************************************************/
                                                                    args: [frm.frameId, extId, tabId, msg.title],
                                                                    //実行コード
                                                                    func: (frameId, extId, tabId, title) => {
                                                                        /*******************************************
                                                                         *sendEmailメッセージ executeScript()の処理関数
                                                                         *特定のtabIdの特定のframeIdで動作
                                                                         ********************************************/
                                                                        console.log("Msg■sendEmail  このフレーム(" + frameId + ")のbody要素にclickリスナーを登録します。　" + frameId);
                                                                        /**********************************************
                                                                         *このsendEmail()関数が見つからないのは、
                                                                         *単にsendEmail()を呼び出すだけではダメで、一工夫して
                                                                         *jqueryのtrigger()メソッドを使用するとうまく行く。
                                                                         *なぜ、sendEmail()はダメなのかは不明。 
                                                                         ***********************************************/
                                                                        $('#sendEmail').trigger('click');
                                                                        //$('#sendEmailBack').trigger('click',['これは']);

                                                                    }       //end func() executeScript()
                                                                });         //end executeScript()
                                                            }
                                                            catch (err) {
                                                                console.error(`failed to execute script: ${err}`);
                                                            }
                                                        });
                                                        console.log("sendResponseを返します。");
                                                        sendResponse({sts: "completed"});
                                                    }
                                                    else {

                                                    }
                                                }   //try()
                                                catch (e) {

                                                }
                                            }       // end for()
                                        })();       //end async()
                                        console.log("Msg■sendEmail  " + tabId);
                                        //await sleep(0.5);
                                    }
                                    else {

                                    }
                                }
                                catch (e) {
                                    //なし
                                }
                            }
                        }
                    });
                    console.log("sendEmail = ");
                    /***********************************************************
                     *これは、必要
                     *後のsendResponse()を有効にするため、 
                     ***********************************************************/
                    return true;
                    break;
                    /*****************************************************
                     *altTriggerメッセージ
                     *任意の動画で、altKey+clickすると、ownId以外のframeIdで
                     *続けてexecuteScript()を出せば、ボタン情報を表示可能。 
                     * 
                     *****************************************************/
                case "altTrigger":
                    //
                    console.log("altTrigger ariaLabe = " + msg.ariaLabel);

                    ariaLabel = msg.ariaLabel;
                    title = msg.title;
                    ownId = msg.ownId;
                    tabId = msg.tabId;
                    frm_arr = msg.frm_arr;

                    console.log("altTrigger受信 ownId  " + ownId);
                    //整形
                    frm_data = [];
                    /*************************************************
                     * 各動画のデータを取得して、配列に保存
                     * frm_arr frameIdの配列
                     **************************************************/
                    data = [];
                    /*****************************************************
                     * 先にownId以外のframeIdとtabIdに対してexecuteScript()を実行
                     * して情報をpopへ表示
                     * 
                     *******************************************************/
                    for (const frm of frm_arr) {
                        console.log("●altTrigger dd = " + frm);
                        //
                        chrome.scripting.executeScript({
                            target: {tabId: tabId, frameIds: [frm]},
                            files: ["jquery.js"]
                        }).then(() => {
                            //ここでもexecuteScript()を出す
                            chrome.scripting.executeScript({
                                //ターゲットのフレームIdのDOMへアクセス  
                                target: {tabId: tabId, frameIds: [frm]},
                                //
                                args: [data, tabId, frm, html],
                                //実行コード
                                func: (data, tabId, frmId, html) => {
                                    /***********************************************************************
                                     *altTrigger executeScriptスクリプトを実行 
                                     *
                                     * 
                                     ************************************************************************/
                                    let vid_;
                                    let frameId;
                                    let title;
                                    let ariaLabel;
                                    let aa = document.querySelector(".ytp-play-button");
                                    vid_ = document.URL.split("/")[4].split("?")[0];
                                    //
                                    vid = vid_;
                                    tabid = tabId;
                                    frameid = frmId;
                                    title = document.title;
                                    ariaLabel = aa.ariaLabel;

                                    console.log("frm of frm_arr = " + title + "  " + ariaLabel);
                                    /*********************************************************************
                                     *このhtmデータを保存して、
                                     *
                                     * 次のexecuteScript()の実行時、取得したい。
                                     *   
                                     ************************************************************************/
                                    //このhtmlデータは、フレームId 0に引き継ぐ
                                    //保存は場所は、DB 動画毎に保存
                                    let params = {
                                        vid: vid,
                                        tabId: tabid,
                                        frameId: frameid,
                                        title: title,
                                        ariaLabel: ariaLabel
                                    };
                                    var data = $.ajax({
                                        url: 'https://favorite.tecoyan.net/slim/save_jimdo.php',
                                        type: 'POST',
                                        dataType: 'html',
                                        cache: false,
                                        data: params,
                                        async: false
                                    }).responseText;
                                    console.log("DB保存しました。" + title);

                                    //alert("save_jimdo.php 512行  aa.title= " + aa.title + " aa.ariaLabel= " + aa.ariaLabel);

                                }

                            });


                        });

                    }
                    /***************************************************************
                     * frm 0に対して、
                     * executeScript()を出す。
                     * 親フレームで、実行
                     * pop要素にhtmlデータを出力
                     * 
                     ***************************************************************/
                    chrome.scripting.executeScript({
                        target: {tabId: tabId, frameIds: [0]},
                        files: ["jquery.js"]
                    }).then(() => {
                        //ここでもexecuteScript()を出す
                        chrome.scripting.executeScript({
                            //ターゲットのフレームIdのDOMへアクセス  
                            target: {tabId: tabId, frameIds: [0]},
                            //htmlデータを渡すには、?????
                            args: [html],
                            //実行コード
                            func: () => {
                                /***********************************************************
                                 *altTrigger executeScript() 
                                 * 
                                 ************************************************************/
                                document.removeEventListener('click', save_hover());                                                        //
                                document.addEventListener('click', save_hover());
                                //
                                function save_hover() {
                                    //alert("ホバーのデータをDBに保存します。");
                                }

                            }

                        });


                    });
                    //
                    return true;
                    break;
            }
        }
);
